#include <stdio.h>

/*      */
#define MAXN 150

/*     */
const unsigned n = 6;
/*      */
int A[MAXN][MAXN] = {
  { 0, 1, 0, 0, 0, 1 },
  { 1, 0, 1, 0, 0, 0 },
  { 0, 1, 0, 1, 0, 0 },
  { 0, 0, 1, 0, 1, 0 },
  { 0, 0, 0, 1, 0, 1 },
  { 1, 0, 0, 0, 1, 0 }};

/* //     
   const unsigned n = 5;
   int A[MAXN][MAXN] = {
     { 0, 1, 0, 0, 1},
     { 1, 0, 1, 0, 0},
     { 0, 1, 0, 1, 0},
     { 0, 0, 1, 0, 1},
     { 1, 0, 0, 1, 0}};
 */

char trOrient(void)
{ /*       */
  unsigned i, j, k, r, tr = 0;
  char flag;
  for (i = 0; i < n - 1; i++)
    for (j = i + 1; j < n; j++)
      if (A[i][j]) tr++;

  r = 0;
  do {
    for (i = 0; i < n; i++) { /*  1     (i,j) */
      for (j = 0; j < n; j++)
        if (1 == A[i][j]) {
          A[i][j] = 2;
          A[j][i] = -2;
          break;
        }
      if (j<n) break;
    }

    /*   1)  2),    */
    do {
      flag = 0;
      for (i = 0; i < n; i++) {
        for (j = 0; j < n; j++) {
          if (2 == A[i][j]) {
            for (k = 0; k < n; k++) {
              if (i != k && j != k) {
                if (0 == A[i][k] || A[i][k] < -2) { /*  2.1) */
                  /* a) ->     */
                  if (2 == A[j][k]) return 1;
                  /* b) ->   (j,k) */
                  if (1 == A[j][k]) { A[k][j] = 2; A[j][k] = -2; flag = 1; }
                }
                if (0 == A[j][k] || A[j][k] < -2) { /*  2.2) */
                  /* a) ->     */
                  if (2 == A[k][i]) return 1;
                  /* b) ->   (j,k) */
                  if (1 == A[i][k]) { A[i][k] = 2; A[k][i] = -2; flag = 1; }
                }
              }
            }
          }
        }
      }
    } while (flag);

    /*  3       */
    for (i = 0; i < n; i++)
      for (j = 0; j < n; j++)
        if (2 == A[i][j]) {
          A[i][j] = -3; A[j][i] = -4; r++;
        }
  } while (r < tr);

  /* ,        */
  return 0;
}

void printGraph(void)
{ unsigned i, j;
  printf("  : \n");
  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++)
      if (-3 == A[i][j]) printf("  1");
        else (-4 == A[i][j]) ? printf(" -1") : printf("  0");
    printf("\n");
  }
}

int main(void) {
  if (trOrient())
    printf("   ! \n");
  else
    printGraph();
  return 0;
}
