#include <stdio.h>

/*      */
#define MAXN 200

/*     */
const unsigned n = 14;
const unsigned sv =  1; /*   */
const unsigned ev = 10; /*   */

/*      */
const char A[MAXN][MAXN] = {
{0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0},
{0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0},
{0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1},
{0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
{0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1},
{0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0}
};

char used[MAXN];
unsigned path[MAXN], count;

void printPath(void)
{ unsigned k;
  for (k = 0; k <= count; k++) printf("%u ", path[k] + 1);
  printf("\n");
}

/*       i   j */
void allDFS(unsigned i, unsigned j)
{ unsigned k;
  if (i == j) {
    path[count] = j;
    printPath();
    return;
  }

  /*     */
  used[i] = 1;
  path[count++] = i;
  for (k = 0; k < n; k++)  /*      i */
    if (A[i][k] && !used[k]) allDFS(k, j);
  /* :     */
  used[i] = 0; count--;
}

int main(void) {
  unsigned k;
  for (k = 0; k < n; k++) used[k] = 0;
  count = 0;
  printf("   %u  %u: \n", sv, ev);
  allDFS(sv-1, ev-1);
  return 0;
}
