#include <stdio.h>

/*      */
#define MAXN 200

/*     */
const unsigned n = 14;
/*      */
const char A[MAXN][MAXN] = {
{0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0},
{0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0},
{0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1},
{0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
{0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1},
{0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0}
};

char used[MAXN], cycl;

/*  Depth-First-Search */
void DFS(unsigned i, int parent)
{ unsigned k;
  used[i] = 1;
  for (k = 0; k < n; k++) {
    if (cycl) return;
    if (A[i][k]) {
      if (used[k] && k != parent) {
        printf("  ! \n");
        cycl = 1;
        return;
      }
      else if (k != parent)
        DFS(k, i);
    }
  }
}

int main(void) {
  unsigned k, i;
  for (k = 0; k < n; k++) used[k] = 0;
  cycl = 0;
  for (i = 0; i < n; i++) {
    if (!used[i]) DFS(i, -1);
    if (cycl) break;
  }
  if (0 == cycl) printf("    (  )!\n");
  return 0;
}
